EDIT - bug #9593

Changing and saving a PolytomousKey throws ConcurrentModificationException
04/27/2021 03:43 PM - Andreas Mller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 90%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.23

Severity: normal Found in Version:

Description

Associated revisions

Revision 98ac7b26 - 04/28/2021 12:02 PM - Katja Luther
ref #9593: add polytomouskey handling in PostMergeEntityListener to avoid NULL values

Revision 4ce176cc - 04/28/2021 12:58 PM - Katja Luther
ref #9593: add polytomouskey handling in PostMergeEntityListener to avoid NULL values - avoid NPE

Revision 78dff9c8 - 04/29/2021 03:31 PM - Katja Luther

ref #9593: revert some changes in taxonDao not belonging to this ticket

History

#1 - 04/27/2021 04:41 PM - Andreas Miiller

- Assignee changed from Andreas Miiller to Katja Luther
- Priority changed from New to Highest

- % Done changed from 0 to 10

This only seems to happen if the sortindex of the PolytomousKey nodes is not up-to-date. After calling refresh on the key saving works.

So it is related to #5681.

Before closing this ticket can you please debug which collection is concurrently modified and why (propably it is the PKNode.children collection but |
am not sure why.

#3 - 04/28/2021 11:46 AM - Katja Luther
Andreas Muller wrote:
This only seems to happen if the sortindex of the PolytomousKey nodes is not up-to-date. After calling refresh on the key saving works.
So it is related to #5681.
Before closing this ticket can you please debug which collection is concurrently modified and why (propably it is the PKNode.children collection

but | am not sure why.

As the problem disappears after updating the sortindex, the children collection seems to cause the problems.

#4 - 04/28/2021 12:04 PM - Katja Luther
- Status changed from New to Resolved

- Assignee changed from Katja Luther to Andreas Miiller

Added the handling of polytomous key in removeNullFromCollection because the editor saves the whole key.

#6 - 04/29/2021 01:12 PM - Andreas Miller

- Status changed from Resolved to Feedback
- Assignee changed from Andreas Mtiller to Katja Luther

- % Done changed from 10 to 90

Probably this is ok, though | wonder why the root node is not doing the same job as it is merge-cascaded. But as the incorrect sortindex numbers
appeared from time to time in PKSs this might be the reason.
We have to watch this.

Generally this ticket can be closed.

Only one issue: the commit 4ce176cc6b710274 also contains code which seems to belong to another ticket. Can you please attache the commit also
to the other ticket (what ever it is)?

#7 - 04/29/2021 03:32 PM - Katja Luther
- Status changed from Feedback to Closed

Andreas Muller wrote:

Probably this is ok, though | wonder why the root node is not doing the same job as it is merge-cascaded. But as the incorrect sortindex numbers
appeared from time to time in PKs this might be the reason.
We have to watch this.

Generally this ticket can be closed.

Only one issue: the commit 4ce176cc6b710274 also contains code which seems to belong to another ticket. Can you please attache the commit
also to the other ticket (what ever it is)?

| removed it

#8 - 05/17/2021 09:52 AM - Andreas Miiller

- Target version changed from Release 5.25 to Release 5.23
